"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_test_renderer_1 = __importDefault(require("react-test-renderer"));
var createPageWrapper_1 = __importDefault(require("../createPageWrapper"));
describe('createPageWrapper', function () {
    var Page = /** @class */ (function (_super) {
        __extends(Page, _super);
        function Page() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Page.prototype.render = function () {
            return React.createElement("view", null, "hi");
        };
        return Page;
    }(React.Component));
    it('get Page ref', function () {
        var WrappedPage = createPageWrapper_1.default(Page, '');
        var testRenderer = react_test_renderer_1.default.create(React.createElement(WrappedPage, { page: null, query: {} }));
        var instance = testRenderer.getInstance();
        expect(instance.pageComponentInstance).toBeInstanceOf(Page);
    });
    it('get Page ref with HOC', function () {
        var hoc = function (PageComponent) {
            return React.forwardRef(function (_, ref) {
                return React.createElement(PageComponent, { ref: ref });
            });
        };
        var WrappedPage = createPageWrapper_1.default(hoc(Page), '');
        var testRenderer = react_test_renderer_1.default.create(React.createElement(WrappedPage, { page: null, query: {} }));
        var instance = testRenderer.getInstance();
        expect(instance.pageComponentInstance).toBeInstanceOf(Page);
    });
    it('does not pass ref to FC', function () {
        var FCPage = function (props) { return React.createElement("view", null, "hi"); };
        var WrappedPage = createPageWrapper_1.default(FCPage, '');
        var testRenderer = react_test_renderer_1.default.create(React.createElement(WrappedPage, { page: null, query: {} }));
        var instance = testRenderer.getInstance();
        expect(instance.pageComponentInstance).toBeNull();
    });
});
