export declare type Callback = (...args: any[]) => any;
export declare enum Lifecycle {
    load = "load",
    show = "show",
    hide = "hide",
    ready = "ready",
    pullDownRefresh = "pullDownRefresh",
    reachBottom = "reachBottom",
    pageScroll = "pageScroll",
    shareAppMessage = "shareAppMessage",
    shareTimeline = "shareTimeline",
    titleClick = "titleClick",
    optionMenuClick = "optionMenuClick",
    popMenuClick = "popMenuClick",
    pullIntercept = "pullIntercept",
    back = "back",
    keyboardHeight = "keyboardHeight",
    tabItemTap = "tabItemTap",
    beforeTabItemTap = "beforeTabItemTap",
    resize = "resize",
    unload = "unload"
}
export declare enum AppLifecycle {
    launch = "launch",
    show = "show",
    hide = "hide",
    error = "error",
    shareAppMessage = "shareAppMessage",
    pageNotFound = "pageNotFound",
    unhandledRejection = "unhandledRejection",
    themeChange = "themeChange"
}
export declare function lifeCycleName(name: string): Lifecycle;
export declare function callbackName(name: string): string;
export declare function registerLifecycle(instance: any, method: Lifecycle | AppLifecycle, callback: Callback): any;
